<?php

defined('_JEXEC') or die('Restricted access');
class plgHikashoppaymentDakhlestan extends hikashopPaymentPlugin
{
    public $accepted_currencies = [
        'IRR', 'TOM',
    ];

    public $multiple = true;
    public $name = 'aqayepardakht';
    public $doc_form = 'aqayepardakht';

    public function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }

    public function onBeforeOrderCreate(&$order, &$do)
    {
        if (parent::onBeforeOrderCreate($order, $do) === true) {
            return true;
        }

        if (empty($this->payment_params->merchant)) {
            $this->app->enqueueMessage('Please check your &quot;aqayepardakht&quot; plugin configuration');
            $do = false;
        }
    }

    public function onAfterOrderConfirm(&$order, &$methods, $method_id)
    {
        parent::onAfterOrderConfirm($order, $methods, $method_id);

        $callBackUrl = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment='.$this->name.'&tmpl=component&lang='.$this->locale.$this->url_itemid.'&orderID='.$order->order_id;
        $amount = round($order->cart->full_total->prices[0]->price_value_with_tax, (int) $this->currency->currency_locale['int_frac_digits']);

        $f = array(
            'amount'        => $amount,
            'pin'           => $this->payment_params->merchant,
            'callback'      => $callBackUrl,
            'bank'          => 'mellat',
            'description'   => 'پرداخت سفارش شماره: '.$order->order_id,
        );

        $f_ = '';
        foreach($f as $k=>$v)
            $f_ .= $k . '=' . urlencode($v) . '&';

        rtrim($f_, '&');

        $ch = curl_init();
        curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/create/");
        curl_setopt($ch,CURLOPT_POST, count($f));
        curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
        curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);
        curl_close($ch);

        if(strlen($result) > 5){
            $this->payment_params->url = 'https://panel.aqayepardakht.ir/startpay/'.$result;
            return $this->showPage('end');
        } else {
            echo "<p align=center>Bank Error $result.<br />Order UNSUCCSESSFUL!</p>";
            exit;
        }
    }

    public function onPaymentNotification(&$statuses)
    {
        $filter = JFilterInput::getInstance();

        $dbOrder = $this->getOrder($_REQUEST['orderID']);
        $this->loadPaymentParams($dbOrder);
        if (empty($this->payment_params)) {
            return false;
        }
        $this->loadOrderData($dbOrder);
        if (empty($dbOrder)) {
            echo 'Could not load any order for your notification '.$_REQUEST['orderID'];

            return false;
        }
        $order_id = $dbOrder->order_id;

        $url = HIKASHOP_LIVE.'administrator/index.php?option=com_hikashop&ctrl=order&task=edit&order_id='.$order_id;
        $order_text = "\r\n".JText::sprintf('NOTIFICATION_OF_ORDER_ON_WEBSITE', $dbOrder->order_number, HIKASHOP_LIVE);
        $order_text .= "\r\n".str_replace('<br/>', "\r\n", JText::sprintf('ACCESS_ORDER_WITH_LINK', $url));

        if (!empty($_POST['transid'])) {
            $history = new stdClass();
            $history->notified = 0;
            $history->amount = round($dbOrder->order_full_price, (int) $this->currency->currency_locale['int_frac_digits']);
            $history->data = ob_get_clean();


            $f = array(
                'amount'    => $history->amount,
                'pin'       => $this->payment_params->merchant,
                'transid'   => $_POST['transid'],
            );

            $f_ = '';
            foreach($f as $k=>$v)
                $f_ .= $k . '=' . urlencode($v) . '&';

            rtrim($f_, '&');

            $ch = curl_init();
            curl_setopt($ch,CURLOPT_URL, "https://panel.aqayepardakht.ir/api/verify/");
            curl_setopt($ch,CURLOPT_POST, count($f));
            curl_setopt($ch,CURLOPT_POSTFIELDS, $f_);
            curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
            $result = curl_exec($ch);
            curl_close($ch);
            if($result == 1)
            {
                $order_status = $this->payment_params->verified_status;
                $msg = 'پرداخت شما با موفقیت انجام شد.';
            }else{
                $order_status = $this->payment_params->pending_status;
                $order_text = JText::sprintf('CHECK_DOCUMENTATION', HIKASHOP_HELPURL.'payment-aqayepardakht-error#verify')."\r\n\r\n".$order_text;
                $msg = 'پرداخت انجام نشد. 1';

            }






            $config = &hikashop_config();
            if ($config->get('order_confirmed_status', 'confirmed') == $order_status) {
                $history->notified = 1;
            }

            $email = new stdClass();
            $email->subject = JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER', 'aqayepardakht', $order_status, $dbOrder->order_number);
            $email->body = str_replace('<br/>', "\r\n", JText::sprintf('PAYMENT_NOTIFICATION_STATUS', 'aqayepardakht', $order_status)).' '.JText::sprintf('ORDER_STATUS_CHANGED', $order_status)."\r\n\r\n".$order_text;
            $this->modifyOrder($order_id, $order_status, $history, $email);
        } else {
            $order_status = $this->payment_params->invalid_status;
            $email = new stdClass();
            $email->subject = JText::sprintf('NOTIFICATION_REFUSED_FOR_THE_ORDER', 'aqayepardakht').'invalid transaction';
            $email->body = JText::sprintf("Hello,\r\n A aqayepardakht notification was refused because it could not be verified by the aqayepardakht server (or pay cenceled)")."\r\n\r\n".JText::sprintf('CHECK_DOCUMENTATION', HIKASHOP_HELPURL.'payment-aqayepardakht-error#invalidtnx');
            $action = false;
            $this->modifyOrder($order_id, $order_status, null, $email);
        }
        header('location: '.HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=order');
        exit;
    }

    public function onPaymentConfiguration(&$element)
    {
        $subtask = JRequest::getCmd('subtask', '');

        parent::onPaymentConfiguration($element);
    }

    public function onPaymentConfigurationSave(&$element)
    {
        return true;
    }

    public function getPaymentDefaultValues(&$element)
    {
        $element->payment_name = 'درگاه پرداخت آقای پرداخت';
        $element->payment_description = '';
        $element->payment_images = '';

        $element->payment_params->invalid_status = 'cancelled';
        $element->payment_params->pending_status = 'created';
        $element->payment_params->verified_status = 'confirmed';
    }
}
